import fs from 'fs'
import { mdRenderer, njkRenderer } from './siteRenderer.js'


// Handle all request and try to find a corresponding file/template.
export function requestHandler(req, res, Config) {
    // Check for njk files first
    if (fs.existsSync(`./${Config.contentDir}/pages/${req.path}.njk`))
        return res.send(njkRenderer(`./${Config.contentDir}/pages/${req.path}.njk`))
    if (fs.existsSync(`./${Config.contentDir}/pages/${req.path}/index.njk`))
        return res.send(njkRenderer(`./${Config.contentDir}/pages/${req.path}/index.njk`))

    // Secondly search for markdown
    if (fs.existsSync(`./${Config.contentDir}/pages/${req.path}.md`))
        return res.send(mdRenderer(`./${Config.contentDir}/pages/${req.path}.md`))
    if (fs.existsSync(`./${Config.contentDir}/pages/${req.path}/index.md`))
        return res.send(mdRenderer(`./${Config.contentDir}/pages/${req.path}/index.md`))

    // If no matching file is found, return a 404 error.
    return res.status(404).send(njkRenderer(`./${Config.contentDir}/errors/404.njk`))
}